local modUtil = require "merk_modutil_1"

local options_br_423 = {
	sbahn_m = { type = "boolean", default = false, order = 1,  name = _("BR 423 S-Bahn München"), description = _("option_sbahn_m_desc"), image = "res/textures/ui/models_small/vehicle/train/br_423_front_sbahn_m.tga" },		
	sbahn_m_40j = { type = "boolean", default = false, order = 2, name = _("BR 423 40 Jahre S-Bahn München"), description = _("option_sbahn_m_40j_desc"), image = "res/textures/ui/models_small/vehicle/train/br_423_front_sbahn_m_40j.tga" },	
	sbahn_m_blb = { type = "boolean", default = false, order = 3, name = _("BR 423 S-Bahn München - Bahnland Bayern"), description = _("option_sbahn_m_blb_desc"), image = "res/textures/ui/models_small/vehicle/train/br_423_front_sbahn_m_blb.tga" },	
	sbahn_m_gcs = { type = "boolean", default = false, order = 4, name = _("BR 423 S-Bahn München - Gartencenter Seebauer"), description = _("option_sbahn_m_gcs_desc"), image = "res/textures/ui/models_small/vehicle/train/br_423_front_sbahn_m_gcs.tga" },	
	sbahn_m_azu = { type = "boolean", default = false, order = 5, name = _("BR 423 S-Bahn München - Azubiyo.de"), description = _("option_sbahn_m_azu_desc"), image = "res/textures/ui/models_small/vehicle/train/br_423_front_sbahn_m_azu.tga" },	
	sbahn_m_dgb = { type = "boolean", default = false, order = 6, name = _("BR 423 S-Bahn München - DGB"), description = _("option_sbahn_m_dgb_desc"), image = "res/textures/ui/models_small/vehicle/train/br_423_front_sbahn_m_dgb.tga" },
	sbahn_m_ehc = { type = "boolean", default = false, order = 7, name = _("BR 423 S-Bahn München - EHC Redbull München"), description = _("option_sbahn_m_ehc_desc"), image = "res/textures/ui/models_small/vehicle/train/br_423_front_sbahn_m_ehc.tga" },	
	sbahn_m_es = { type = "boolean", default = false, order = 8, name = _("BR 423 S-Bahn München - Edeka Simmel"), description = _("option_sbahn_m_es_desc"), image = "res/textures/ui/models_small/vehicle/train/br_423_front_sbahn_m_es.tga" },	
	sbahn_k = { type = "boolean", default = false, order = 9, name = _("BR 423 S-Bahn Köln"), description = _("option_sbahn_k_desc"), image = "res/textures/ui/models_small/vehicle/train/br_423_front_sbahn_k.tga" },	
	sbahn_rm = { type = "boolean", default = false, order = 10, name = _("BR 423 S-Bahn Rhein-Main"), description = _("option_sbahn_rm_desc"), image = "res/textures/ui/models_small/vehicle/train/br_423_front_sbahn_rm.tga" },
	sbahn_rm_rd = { type = "boolean", default = false, order = 11, name = _("BR 423 S-Bahn Rhein-Main Redesign"), description = _("option_sbahn_rm_rd_desc"), image = "res/textures/ui/models_small/vehicle/train/br_423_front_sbahn_rm_rd.tga" },
	sbahn_s = { type = "boolean", default = false, order = 12, name = _("BR 423 S-Bahn Stuttgart"), description = _("option_sbahn_s_desc"), image = "res/textures/ui/models_small/vehicle/train/br_423_front_sbahn_s.tga" },
	sbahn_s_rd_wl = { type = "boolean", default = false, order = 13, name = _("BR 423 S-Bahn Stuttgart Redesign"), description = _("option_sbahn_s_rd_wl_desc"), image = "res/textures/ui/models_small/vehicle/train/br_423_front_sbahn_s_rd_wl.tga" },		
	sbahn_rr_422 = { type = "boolean", default = false, order = 14, name = _("BR 422 S-Bahn Rhein-Ruhr"), description = _("option_sbahn_rr_desc"), image = "res/textures/ui/models_small/vehicle/train/br_422_front_sbahn_rr_422.tga" },	
	sbahn_rr_azu_422 = { type = "boolean", default = false, order = 15, name = _("BR 422 S-Bahn Rhein-Ruhr Azubiyo.de"), description = _("option_sbahn_rr_azu_desc"), image = "res/textures/ui/models_small/vehicle/train/br_422_front_sbahn_rr_azu_422.tga" },	
	sbahn_rr_c8_422 = { type = "boolean", default = false, order = 16, name = _("BR 422 S-Bahn Rhein-Ruhr China 8"), description = _("option_sbahn_rr_c8_desc"), image = "res/textures/ui/models_small/vehicle/train/br_422_front_sbahn_rr_c8_422.tga" },	
	sbahn_rr_kf_422 = { type = "boolean", default = false, order = 17, name = _("BR 422 S-Bahn Rhein-Ruhr Kautionsfrei.de"), description = _("option_sbahn_rr_kf_desc"), image = "res/textures/ui/models_small/vehicle/waggon/br_422_mitte_sbahn_rr_kf_422.tga" },	
	sbahn_rr_vrr_422 = { type = "boolean", default = false, order = 18, name = _("BR 422 S-Bahn Rhein-Ruhr VRR Redesign"), description = _("option_sbahn_rr_vrr_desc"), image = "res/textures/ui/models_small/vehicle/train/br_422_front_sbahn_rr_vrr_422.tga" },	
	sbahn_rm_430 = { type = "boolean", default = false, order = 19, name = _("BR 430 S-Bahn Rhein-Main"), description = _("option_sbahn_rm_430_desc"), image = "res/textures/ui/models_small/vehicle/train/br_430_front_sbahn_rm_430.tga" },	
	sbahn_s_430 = { type = "boolean", default = false, order = 20, name = _("BR 430 S-Bahn Stuttgart"), description = _("option_sbahn_s_430_desc"), image = "res/textures/ui/models_small/vehicle/train/br_430_front_sbahn_s_430.tga" },	
	
}

function data()
return {
	info = {
		minorVersion = 4,
		severityAdd = "NONE",
		severityRemove = "WARNING",
		name = _("S-Bahnen BR 423/422/430"),
		description = _("info_br_423_desc"),
		tags = { "Europe", "Multiple Unit", },
		authors = {
			{
				name = "Kaleut1988",
				role = "CREATOR",
				text = "3D-Modell, Texturen",
				tfnetId = 22532,
			},
			{
				name = "Freahk",
				role = "CO_CREATOR",
				text = "Filefilter",
				tfnetId = 21483,
			},
			{
				name = "Yoshi",
				role = "CO_CREATOR",
				text = "div. Werbelackierungen",
				tfnetId = 21340,
			},
			{
				name = "flummi1701",
				role = "CO_CREATOR",
				text = "SOUND",
				tfnetId = 21780,
			},			
		},
		tfnetId = 3221,                 							-- optional, transportfever.net id
		steamId = 0,             								-- optional, steam workshop id
		url = "https://www.transportfever.net/filebase/index.php/Entry/3221-S-Bahnen-BR-423-422-430/", 												-- optional, URL zur Webseite des Mods
		visible = true		
	},	
	settings = options_br_423,
		
	runFn = function(settings)
		modUtil.initialize("kaleut_br_423", options_br_423)

		-- erstelle den fileFilter.
		-- fileName ist je nachdem wo die Datei gespeichert ist (UG bitte...) der vollständige Pfad der Datei oder der Pfad zum TpF Hauptverzeichnis. 
		-- data enthält die komplette tabe die durch aufrufen der data Funktion der Datei erzeugt wurde.
		-- Wir wollen folgende Dateien ggf. raus filtern:
		-- br_423_front_*.mdl
		-- br_423_mitte_*.mdl
		-- br_423_mitte_panto_*.mdl
		-- br_423_end_*.mdl
		-- br_423_*.lua

		local settings=modUtil.userSettings.get('kaleut_br_423') -- settings ist jetzt z.B. {sbahn_m=true, sbahn_m_40j=true}, wir wissen also was aktiv sein soll und was nicht.		
		local blacklistSet = {}
		for key, value in pairs(settings) do
			if(value==false) then
				blacklistSet['front_'..key..'.mdl']=true
				blacklistSet['mitte_'..key..'.mdl']=true
				blacklistSet['mitte_panto_'..key..'.mdl']=true
				blacklistSet['end_'..key..'.mdl']=true
				blacklistSet[key..'.lua']=true
			end
		end
		
		local muAndMdlFilter = function(fileName, data)
      -- Naja ich mag diese kastrierten lua regExps nicht. Die expressions sollten aber ihren Zweck erfüllen.
      local subName=fileName:match('/br_423_([^/]*%.[lm][ud][al])') or
                    fileName:match('/br_422_([^/]*%.[lm][ud][al])') or
                    fileName:match('/br_430_([^/]*%.[lm][ud][al])')
      return (subName==nil or blacklistSet[subName]~=true)
        end

		-- Filter registrieren.
		addFileFilter("multipleUnit", muAndMdlFilter)		
		addFileFilter("model/vehicle", muAndMdlFilter)
	end
}
end
