local soundeffectsutil = require "soundeffectsutil"

function data()
return {

	tracks = {
	
        { name = "vehicle/train_trieb423/leerlauf.wav", refDist = 25.0 },	
        { name = "vehicle/train_trieb423/wechsler.wav", refDist = 25.0 },
		{ name = "vehicle/train_trieb423/anfahrt.wav", refDist = 25.0 },		
		{ name = "vehicle/train_trieb423/wechsler.wav", refDist = 25.0 },

	    { name = "vehicle/train_trieb423/wechsler.wav", refDist = 25.0 },
	    { name = "vehicle/train_trieb423/wechsler.wav", refDist = 25.0 },		
        { name = "vehicle/train_trieb423/wechsler.wav", refDist = 25.0 },
        { name = "vehicle/train_trieb423/wechsler.wav", refDist = 25.0 },		

		{ name = "vehicle/5_waggon_effects/fahrt/pers_w_schnell.wav", refDist = 25.0 },			
		{ name = "vehicle/5_waggon_effects/fahrt/trieb_abroll_vorne.wav", refDist = 15.0 },

		{ name = "vehicle/1_train_effects/trieb_kurve.wav", refDist = 20.0 },
		{ name = "vehicle/1_train_effects/trieb_bremse.wav", refDist = 25.0 }

	},
	
	events =  {
          horn = { names = { "vehicle/train_trieb423/horn.wav" }, refDist = 25.0 },		  
		  openDoors = { names = { "vehicle/train_trieb423/open_doors3500ms.wav" }, refDist = 5.0 },	
		  closeDoors = { names = { "vehicle/train_trieb423/close_doors3500ms.wav" }, refDist = 5.0 }
			
	},
	
    updateFn = function (input)
		local axleRefWeight = 10.0
		
		return {
		    tracks = {
			    -- Leerlauf Stand				
				{ 
					gain = soundeffectsutil.sampleCurve({ 
									{ 0.0, 0.2 },
									{ 0.05, 0.0 },
									{ 1.0, 0.0 } }, input.speed01),
					pitch = soundeffectsutil.sampleCurve({ 
									{ 0.0, 1.0 },
    					            { 1.0, 1.0 } }, input.speed01)
				},				
			    -- Wechsler Start				
				{ 
					gain = soundeffectsutil.sampleCurve({ 
									{ 0.0, 0.0 },
									{ 0.001, 0.0 },
									{ 0.05, 0.3 },
									{ 0.30, 0.3 },
									{ 0.3001, 0.0 },
									{ 1.0, 0.0 } }, input.speed01),
					pitch = soundeffectsutil.sampleCurve({ 
									{ 0.0, 0.8 },
									{ 0.05, 0.8 },
									{ 0.25, 0.8 },
									{ 0.30, 1.0 },
									{ 0.3001, 0.0 },
						            { 1.0, 0.0 } }, input.speed01)
				},
			    -- Anfahrt/Nebengeräusch				
				{ 
					gain = soundeffectsutil.sampleCurve({ 
									{ 0.0, 0.0 },
									{ 0.15, 0.0 },
									{ 0.20, 0.6 },
									{ 0.40, 0.4 },
									{ 1.0, 0.3 } }, input.speed01),
					pitch = soundeffectsutil.sampleCurve({ 
									{ 0.0, 1.0 },
									{ 0.15, 1.0 },
									{ 0.40, 1.0 },
    					            { 1.0, 1.9 } }, input.speed01)
				},				
			    -- Fahrt Motor 1				
				{ 
					gain = soundeffectsutil.sampleCurve({ 
									{ 0.0, 0.0 },
									{ 0.25, 0.0 },
									{ 0.35, 0.50 },
									{ 0.375, 0.0 },
									{ 1.0, 0.0 } }, input.speed01),
					pitch = soundeffectsutil.sampleCurve({ 
									{ 0.0, 1.0 },
									{ 0.25, 1.0 },
									{ 0.375, 1.2 },
						            { 1.0, 1.0 } }, input.speed01)
				},
			    -- Fahrt Motor 2				
				{ 
					gain = soundeffectsutil.sampleCurve({ 
									{ 0.0, 0.0 },
									{ 0.35, 0.0 },
									{ 0.375, 0.55 },
									{ 0.40, 0.0 },
									{ 1.0, 0.0 } }, input.speed01),
					pitch = soundeffectsutil.sampleCurve({ 
									{ 0.0, 1.1 },
									{ 0.375, 1.1 },
									{ 0.40, 1.3 },
						            { 1.0, 1.3 } }, input.speed01)
				},					
				-- Fahrt Motor 3	
				{ 
					gain = soundeffectsutil.sampleCurve({ 
									{ 0.0, 0.0 },
									{ 0.375, 0.0 },
									{ 0.40, 0.50 },
									{ 0.45, 0.50 },
									{ 0.47, 0.0 },
						            { 1.0, 0.0 } }, input.speed01),
					pitch = soundeffectsutil.sampleCurve({ 
									{ 0.0, 1.2 },
									{ 0.40, 1.2 },
									{ 0.47, 1.4 },
									{ 1.0, 1.4 } }, input.speed01)
				},
				-- Fahrt Motor 4	
				{ 
					gain = soundeffectsutil.sampleCurve({ 
									{ 0.0, 0.0 },
									{ 0.45, 0.0 },
									{ 0.47, 0.45 },
									{ 0.57, 0.50 },
									{ 0.59, 0.0 },
						            { 1.0, 0.0 } }, input.speed01),
					pitch = soundeffectsutil.sampleCurve({ 
									{ 0.0, 1.3 },
									{ 0.47, 1.3 },
									{ 0.59, 1.5 },
									{ 1.0, 1.5 } }, input.speed01)
				},				
				-- Fahrt Motor 5	
				{ 
					gain = soundeffectsutil.sampleCurve({ 
									{ 0.0, 0.0 },
									{ 0.57, 0.0 },
									{ 0.59, 0.40 },
									{ 0.70, 0.35 },
									{ 0.72, 0.30 },
									{ 0.82, 0.35 },
									{ 0.84, 0.30 },
						            { 1.0, 0.25 } }, input.speed01),
					pitch = soundeffectsutil.sampleCurve({ 
									{ 0.0, 1.4 },
									{ 0.59, 1.4 },
									{ 0.70, 1.55 },
									{ 0.72, 1.35 },
									{ 0.82, 1.45 },
									{ 0.84, 1.3 },
									{ 1.0, 1.4 } }, input.speed01)
				},				
				-- Fahrt Nebengeräusch 
				{ 
					gain = soundeffectsutil.sampleCurve({ 
						            { 0.0, 0.0 },
									{ 0.10, 0.0 },
						            { 1.0, 0.5 } }, input.speed01),
					pitch = soundeffectsutil.sampleCurve({ 
					                { 0.0, 0.5 },
						            { 1.0, 1.1 } }, input.speed01)
				},
			    -- Abrolleffekt				
				{ 
					gain = soundeffectsutil.sampleCurve({ 
									{ 0.0, 0.0 },
									{ 0.4, 0.6 },
									{ 1.0, 0.5 } }, input.speed01),
					pitch = soundeffectsutil.sampleCurve({ 
									{ 0.0, 0.8 },
    					            { 1.0, 1.4 } }, input.speed01)
				},
				
				soundeffectsutil.squeal(input.speed, input.sideForce, input.maxSideForce),
				soundeffectsutil.brake(input.speed, input.brakeDecel, 0.5)
				
			},
			events = {
				horn = { gain = 1.0, pitch = 1.0 },
				openDoors = { gain = 1.0, pitch = 1.0 },
				closeDoors = { gain = 1.0, pitch = 1.2 }				
    		}
		}
	end
}
end
